<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>[[//TOC//]]</title>
<meta name="generator" content="https://txt2tags.org">
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
<h1>[[//TOC//]]</h1>
</hgroup>
</header>


<div class="body">

<section~A~>
<h1></h1>
<section>
<h2>Compilando código fonte em //container//</h2>

<section>
<h3>Motivação</h3>

<p>
O conceito de <em>container</em> não é nenhuma novidade, principalmente entre os círculos sociais mais nerds. Mesmo o Windows (<a href="https://learn.microsoft.com/pt-br/virtualization/windowscontainers/about/">pasmem!</a>) já possui suporte a esse recurso. O que talvez ainda mereça evoluir é a percepção do usuário de que conteinerização tem seu valor <strong>também</strong> em um <em>desktop</em>.
</p>
<p>
<em>Containers</em>: - encapsulam uma aplicação com dependências em grande quantidade ou ausentes dos repositórios da distribuição e/ou que dificilmente serão usadas por outras aplicações, permitindo um compartilhamento bastante simplificado; - evitam conflitos em binários compilados contra bibliotecas de versão incompatível com alguma característica da distribuição instalada no <em>host</em> (como <a href="https://en-m-wikipedia-org.translate.goog/wiki/Glibc?_x_tr_sl=auto&amp;_x_tr_tl=pt">glibc</a> x <a href="https://en-m-wikipedia-org.translate.goog/wiki/Musl?_x_tr_sl=auto&amp;_x_tr_tl=pt">musl</a> e arquitetura de 64 x 32 bits, por exemplo). Nesse sentido, seu uso pode ser encarado como uma alternativa aos sistemas de empacotamento <a href="https://medium-com.translate.goog/@journalehsan/snap-flatpak-and-appimage-which-one-is-better-dc36f7ff1720?_x_tr_sl=auto&amp;_x_tr_tl=pt">snap, flatpak e appImage</a>. Mas, diferentemente destes últimos, em um <em>container</em> é fácil a interação manual no desenvolvimento e na execução do processo, mesmo que normalmente isso seja feito de forma automatizada. Como a aplicação contida não é naturalmente integrada ao ambiente gráfico de trabalho do usuário da mesma forma transparente que esses sistemas de empacotamento, acaba exigindo um pouco de “mão na massa”.
</p>
<p>
Existe todo um rol de vantagens técnicas na adoção de <em>containers</em>. Isolamento de processos, granularidade do consumo de recursos e simplificação da implantação de ambientes em <a href="https://redhat.com/pt-br/topics/devops/what-is-ci-cd">CI/CD</a>, só para citar algumas. Mas não serão elas o foco desse artigo; há mais uma aplicação à qual <em>containers</em> servem como uma luva: a compilação de código fonte.
</p>
<p>
É verdade que atualmente as distribuições Linux vêm carregadas com opções pré-compiladas de uma infinidade de aplicações das mais variadas áreas do conhecimento. O que por vezes acontece é que justamente a versão que <strong>estamos usando</strong> da <strong>nossa</strong> querida distribuição não possui a versão adequada (ou seja, a última :-p) de determinada aplicação, porque foi publicada ontem ou porque falta mão de obra ou interesse entre os mantenedores da distribuição ou simplesmente devido à sua política de atualização. Aquela versão nova da aplicação que mais usamos, que implementou justamente aquela características matadora que vai mudar nossa vida só estará disponível a curto prazo se alguma boa alma de plantão a compilar e disponibilizar o pacote em algum repositório adicional. A alternativa é rezar para que a próxima edição da distro venha atualizada também nesse quesito. Lamentável…
</p>
<p>
Bom. Quem não tem sangue de barata para aguentar tamanha dependência, pode fazer sua própria compilação do código fonte: até isso hoje em dia é trivial no Linux, ainda mais se comparado com a dificuldade de 20 anos atrás.
</p>
<p>
A adoção de <em>containers</em> também para esse fim traz apenas vantagens em relação à compilação no <em>host</em> ou mesmo em VM’s:
</p>

 <ul>
 <li>o instanciamento de um <em>container</em> é ridiculamente simples e rápido;
 </li>
 <li>é possível adotar basicamente qualquer versão de qualquer distribuição;
 </li>
 <li>garante que o procedimento não sofrerá interferência de customizações já aplicadas à instalação do <em>host</em>;
 </li>
 <li>não gera “poluição” no host com compiladores e pacotes de desenvolvimento, já que a instalação do <em>desktop</em> possivelmente não tem esse objetivo;
 </li>
 <li>deixa evidentes as dependências envolvidas no processo, facilitando o processo de documentação e replicação. Containers de distribuições costumam vir com o mínimo absoluto que os deixe utilizáveis, mas nada impede a adoção de imagens especializadas;
 </li>
 <li>a integração de <em>containers</em> com o <em>host</em> é muito mais simples e transparentemente que a de VM’s;
 </li>
 <li>exigem muito menos recursos de RAM e CPU;
 </li>
 <li>permitem também a execução de aplicações gráficas, inclusive de ambientes gráficos, se o <em>container</em> for adequadamente executado e integrado com o ambiente gráfico do <em>host</em>;
 </li>
 <li>é trivial a execução automatizada de uma quantidade/sequência arbitrária de <em>containers</em> executando procedimentos também automatizados;
 </li>
 <li>é possível salvar imagens intermediárias durante o processo de customização, para que sejam usadas como pontos de partida para outros fins;
 </li>
 <li>simplifica uma eventual criação de pacote com o binário resultante, compatível com a versão da distribuiçao que foi executada no <em>container</em>.
 </li>
 </ul>

</section>
<section>
<h3>Possibilidades</h3>

<p>
O Maravilhoso Mundo Encantado dos <em>Containers</em> só é possível porque a <a href="http://wikipedia.org/wiki/linux_namespaces#History">versão 2.4.19 do Linux, lançada em 2002</a>, introduziu suporte ao conceito de <em><a href="https://www-redhat-com.translate.goog/en/blog/7-linux-namespaces?_x_tr_sl=auto&amp;_x_tr_tl=pt">namespace</a></em>. Com base nisso, 10 anos depois, o <a href="http://lwn.net/Articles/491236">kernel 3.8</a> passou a suportar o conceito de <em><a href="https://www.redhat.com/pt-br/topics/containers/whats-a-linux-container">container</a></em>. Um <em>container</em> difere de uma máquina virtual por não executar concomitantemente outro sistema operacional, mas sim processos “azeite” controlados pelo mesmo <em>kernel</em> do <em>host</em> e que “não se misturam” graças aos uso dos <em>namespaces</em>. Para simplificar a criação e manutenção de <em>containers</em>, criou-se mais uma camada, chamada “mecanismo (ou motor) de <em>container</em>” (<em>container engine</em>). É nessa camada que normalmente atuamos quando criamos, modificamos, exportamos e matamos <em>containers</em>.
</p>
<p>
Dentre os vários mecanismos, o <a href="https://docs-docker-com.translate.goog/get-started/docker-overview/?_x_tr_sl=auto&amp;_x_tr_tl=pt">docker</a> sem dúvida é o mais popular, mas há outros. Alguns se destacam em segurança, outros em economia de recurso, outros em simplicidade de execução e, claro, alguns são voltados especificamente para o uso em nuvem:
</p>

 <ul>
 <li><a href="https://docs-podman-io.translate.goog/en/latest/?_x_tr_sl=auto&amp;_x_tr_tl=pt">podman</a>
 </li>
 <li><a href="https://github-com.translate.goog/containerd/containerd/blob/main/README.md?_x_tr_sl=auto&amp;_x_tr_tl=pt">containerd</a>
 </li>
 <li><a href="https://cri--o-io.translate.goog/?_x_tr_sl=auto&amp;_x_tr_tl=pt#what-is-cri-o">CRI-O</a>
 </li>
 <li><a href="https://linuxcontainers-org.translate.goog/lxc/introduction/?_x_tr_sl=auto&amp;_x_tr_tl=pt">LXC</a>
 </li>
 <li><a href="https://docs.redhat.com/pt-br/documentation/red_hat_enterprise_linux/8/html/building_running_and_managing_containers/_runc">runc</a>
 </li>
 <li><a href="https://redhat.com/pt-br/topics/containers/what-is-rkt">rkt</a>
 </li>
 </ul>

</section>
<section>
<h3>A adoção do Podman</h3>

<p>
Neste artigo, a adoção do <code>podman</code> em detrimento do <code>docker</code> deve-se às características interessantes do primeiro para o uso proposto. Um <em>container</em> podman é executado sem necessidade de um <em>daemon</em> ou de privilégios de <em>root</em>, deixando-o mais simples e mais seguro. Sendo executado no espaço do usuário, um diretório do <em>host</em> compartilhado como volume para o <em>container</em> terá seu conteúdo gravado pelo <em>root</em> do <em>container</em> automaticamente pertencente ao usuário que o executou, o que torna transparente o intercâmbio entre o que é feito do lado do <em>host</em> e o que é feito do lado do <em>container</em>. Evidentemente nada impede o uso do docker, até porque a sintaxe dos dois mecanismos é idêntica, mas então é possível que alguns passos a mais tornem-se necessários, especialmente no que diz respeito ao permissionamento.
</p>
<p>
O binário resultante da compilação no <em>container</em> fica diretamente disponível ao <em>host</em> no diretório do código fonte que foi repassado como volume para o <em>container</em>. Pode ser executado de dentro do <em>container</em>, ou a partir do <em>host</em> se o <em>container</em> executou uma distro compatível. Na sequência, é possível empacotá-lo no formato de pacote utilizado no <em>container</em>. A execução de diferentes distros em diferentes versões montando esse mesmo diretório permite originar um pacote para cada combinação apenas recompilando o código fonte para adequar os binários às versões de dependências da distro em questão.
</p>
<p>
Existem outras possibilidades para dar destino ao que foi feito no container, como salvar o <em>layer</em> contendo as modificações em uma imagem separada da imagem original, por exemplo. Mas o foco desta dica é tratar o <em>container</em> como um ajudante invisível, então não vamos explorar o que pode ser feito no universo dele.
</p>

</section>
<section>
<h3>Instalação e configuração do mecanismo</h3>

<pre class="comandos">
<span class="saida">sudo apt install -y podman</span>

<span class="saida">podman --version</span>
<span class="saida"># podman version 5.0.3</span>

<span class="saida">sudo usermod --add-subuids 100000-165535 --add-subgids 100000-165535 $USER</span>
<span class="saida">cat /etc/sub?id</span>
<span class="saida">podman system migrate</span>
<span class="saida">ls -la ~/.local/share/containers</span>
</pre>

</section>
<section>
<h3>Parametrização do //container//</h3>

<pre class="comandos">
<span class="saida">dir=build</span>

<span class="saida">printf -v tz '%(%z)T'</span>
<span class="saida">printf -v tz 'UTC%+05d\n' $(( -1*( ${tz::1}10#${tz:1:2} ) ))</span>

<span class="saida">cd /export/src/git</span>

<span class="saida">cat &lt;&lt; \EOT &gt; container-bashrc</span>

<span class="saida">  unset HISTCONTROL</span>

<span class="saida">  ls="LC_ALL= LC_TIME=C LC_NUMERIC=pt_BR.utf8 BLOCK_SIZE=\'1 ls -lapvT0 --quoting-style=shell --color=always --group-directories-first"</span>
<span class="saida">  alias  l="$ls -is --time-style='+%Y/%m/%d %a %T %:::z'" # --hyperlink</span>
<span class="saida">  alias ll="$ls -gG --time-style='+%Y/%m/%d %T'"</span>
<span class="saida">  alias  h="LC_TIME=C history"</span>

<span class="saida">EOT</span>

<span class="saida">args=(</span>

<span class="saida">   --rm</span>
<span class="saida">   --tty</span>
<span class="saida">   --interactive</span>

<span class="saida">   --volume   $PWD:/$dir</span>
<span class="saida">   --volume   $PWD/container-bashrc:/root/.bashrc</span>
<span class="saida">   --volume   /tmp/.X11-unix:/tmp/.X11-unix</span>

<span class="saida">   --workdir  /$dir</span>
<span class="saida">   --hostname  $dir</span>
<span class="saida">   --name      $dir</span>

<span class="saida">   --env              TZ=$tz # America/Sao_Paulo UTC+03 # $(&lt;/etc/timezone)</span>
<span class="saida">   --env DEBIAN_FRONTEND=noninteractive</span>
<span class="saida">   --env            LANG=pt_BR.utf8</span>
<span class="saida">   --env        LANGUAGE=pt_BR.utf8</span>
<span class="saida">   --env          LC_ALL=pt_BR.utf8</span>
<span class="saida">   --env      TIMEFORMAT=%lR</span>
<span class="saida">   --env    NO_AT_BRIDGE=1 # (Terminal:29743): dbind-WARNING **: 17:24:22.395: Couldn't connect to accessibility bus: Failed to connect to socket /run/user/10101/at-spi/bus_0: No such file or directory</span>

<span class="saida">   --env DISPLAY</span>
<span class="saida"> # --env DBUS_SESSION_BUS_ADDRESS</span>

<span class="saida">)</span>
</pre>

</section>
<section>
<h3>Execução do //container//</h3>

<pre class="comandos">
<span class="saida">. /etc/os-release</span>

<span class="saida">podman pull ubuntu:$VERSION_ID</span>

<span class="saida">podman images | sort</span>

<span class="saida">podman run "${args[@]}" ubuntu:$VERSION_ID bash</span>
</pre>

</section>
<section>
<h3>Customização</h3>

<pre class="comandos">
<span class="saida">apt update</span>

<span class="saida">apt install -y apt-utils</span>
<span class="saida">apt install -y locales time wget curl apt-file file readline-common tzdata command-not-found bash-completion</span>
<span class="saida">apt install -y git git-lfs cmake</span>

<span class="saida">. /etc/profile</span>
<span class="saida">bind -f /etc/inputrc</span>
<span class="saida">locale-gen $LC_ALL</span>

<span class="saida">apt upgrade -y</span>
<span class="saida">apt-file update</span>
</pre>

</section>
<section>
<h3>Exemplos de uso</h3>

<p>
Essa dica propõe-se a ser a base para as próximas, que trarão exemplos didáticos e mesmo lúdicos de uso desse ambiente, tanto em relação à compilação propriamente dita, quanto à funcionalidade do resultado (as dicas em si).
</p>

</section>
<section>
<h3>Referências adicionais</h3>

 <ul>
 <li><a href="http://snapcraft.io/about">http://snapcraft.io/about</a>
 </li>
 <li><a href="http://docs.flatpak.org/en/latest/introduction.html">http://docs.flatpak.org/en/latest/introduction.html</a>
 </li>
 <li><a href="http://docs.appimage.org/introduction">http://docs.appimage.org/introduction</a>
 </li>
 </ul>

</section>
</section>
<section>
<h2>Comandos mencionados nesse artigo</h2>

 <ul>
 <li><a href="http://man.archlinux.org/man/bash.1">bash</a>: <a href="http://man.archlinux.org/man/bash.1#cd">cd</a>
 </li>
 <li><a href="http://man.archlinux.org/man/apt.8">apt</a>
 </li>
 <li><a href="http://man.archlinux.org/man/cat.1">cat</a>
 </li>
 <li><a href="http://man.archlinux.org/man/docker.1">docker</a>
 </li>
 <li><a href="http://man.archlinux.org/man/ls.1">ls</a>
 </li>
 <li><a href="http://man.archlinux.org/man/mkdir.1">mkdir</a>
 </li>
 <li><a href="http://man.archlinux.org/man/podman.1">podman</a>
 </li>
 <li><a href="http://man.archlinux.org/man/sudo.8">sudo</a>
 </li>
 <li><a href="http://man.archlinux.org/man/usermod.8">usermod</a>
 </li>
 </ul>

</section>
</section>
</div>
</body></html>
